
From: Arjan van de Ven <arjanv@redhat.com>

Utz Lehmann <u.lehmann@de.tecosim.com> found a problem with the flexmmap
patches on x86-64, what he is seeing is that the 32 bit personality isn't
set at the first point of setting the allocator strategy.  The solution is
simple, in binfmt_elf the personality is set so put the pick-layout
function there.  Please consider,

Signed-off-by: Arjan van de Ven <arjanv@redhat.com>

Signed-off-by: Andrew Morton <akpm@osdl.org>
---

 25-akpm/fs/binfmt_elf.c |    2 ++
 1 files changed, 2 insertions(+)

diff -puN fs/binfmt_elf.c~flexmmap-patchkit-fix-for-32-bit-emu-for-64-bit-arches fs/binfmt_elf.c
--- 25/fs/binfmt_elf.c~flexmmap-patchkit-fix-for-32-bit-emu-for-64-bit-arches	2004-08-20 01:25:06.143546808 -0700
+++ 25-akpm/fs/binfmt_elf.c	2004-08-20 01:25:06.148546048 -0700
@@ -703,6 +703,8 @@ static int load_elf_binary(struct linux_
 	if (elf_read_implies_exec(elf_ex, have_pt_gnu_stack))
 		current->personality |= READ_IMPLIES_EXEC;
 
+	arch_pick_mmap_layout(current->mm);
+
 	/* Do this so that we can load the interpreter, if need be.  We will
 	   change some of these later */
 	current->mm->rss = 0;
_
